use std::{fs, cell::RefCell, rc::Rc};

const ELEMENT_SEPARATOR:char = '=';
const SIDE_SEPARATOR:char = ',';
const LEFT:char = 'L';
const RIGHT:char = 'R';
const BEGIN:&str = "AAA";
const END:&str = "ZZZ";
const FILE_NAME:&str = "./data/data.txt";
fn main() {
    let file_contents = fs::read_to_string(FILE_NAME).unwrap();
    let mut lines:Vec<&str> = file_contents.split('\n').collect();
    let directions_string = lines.remove(0);
    let directions:Vec<char> = directions_string.chars().collect();
    let mut elements:Vec<Element> = Vec::new();
    _ = lines.remove(0);
    for line in lines{
        if line.is_empty() { break; }
        let (element,sides) = line.split_once(ELEMENT_SEPARATOR).unwrap();
        let element = element.trim();
        let sides = sides.trim();
        let (left,right) = sides.split_once(SIDE_SEPARATOR).unwrap();
        let left:String = left.trim().chars().filter(|c| c.is_alphabetic()).collect();
        let right:String = right.trim().chars().filter(|c| c.is_alphabetic()).collect();

        let mut front_element = Element::new(element.to_string());

        front_element.left_side = left;
        front_element.right_side = right;

        elements.push(front_element);
    }

    let mut current_location_name = BEGIN.to_string();
    let mut next_location_name = String::new();
    let mut index = 0;
    loop {
        if current_location_name.to_string() == END.to_string(){
            break;
        }
        let side = *directions.get(index % directions.len()).unwrap();
        for element in elements.iter(){
            if element.get_name().eq(&current_location_name.clone()){
                match side{
                    LEFT => {
                        next_location_name = element.left();
                        index += 1;
                        break;
                    },
                    RIGHT => {
                        next_location_name = element.right();
                        index += 1;
                        break;
                    },
                    _ => { panic!();}
                }
            }
        }
        current_location_name = next_location_name.clone();
    }

    println!("{:?}",index);
}

#[derive(Clone,Debug)]
struct Element{
    name:String,
    left_side:String,
    right_side:String,
}

impl Element{
    fn new(name:String) -> Self { Self{name, left_side:String::new(),right_side:String::new()} }

    fn get_name(&self) -> &str { &self.name }

    fn left(&self) -> String { self.left_side.clone() }
    fn right(&self) -> String { self.right_side.clone() }
}

impl PartialEq for Element{
    fn eq(&self, other: &Self) -> bool { self.name.eq(&other.name) }
}
