use std::fs;

const ELEMENT_SEPARATOR:char = '=';
const SIDE_SEPARATOR:char = ',';
const LEFT:char = 'L';
const RIGHT:char = 'R';
const BEGIN:char = 'A';
const END:char = 'Z';
const FILE_NAME:&str = "./data/data.txt";
fn main() {
    let file_contents = fs::read_to_string(FILE_NAME).unwrap();
    let mut lines:Vec<&str> = file_contents.split('\n').collect();
    let directions_string = lines.remove(0);
    let directions:Vec<char> = directions_string.chars().collect();
    let mut elements:Vec<Element> = Vec::new();
    let mut begins: Vec<Element> = Vec::new();
    _ = lines.remove(0);
    for line in lines{
        if line.is_empty() { break; }
        let (element,sides) = line.split_once(ELEMENT_SEPARATOR).unwrap();
        let element = element.trim();
        let sides = sides.trim();
        let (left,right) = sides.split_once(SIDE_SEPARATOR).unwrap();
        let left:String = left.trim().chars().filter(|c| c.is_alphanumeric()).collect();
        let right:String = right.trim().chars().filter(|c| c.is_alphanumeric()).collect();

        let mut front_element = Element::new(element.to_string());

        front_element.left_side = left;
        front_element.right_side = right;

        if element.contains(BEGIN) { begins.push(front_element.clone()); }

        elements.push(front_element);
    }

    let mut index = 0;
    loop {
        let mut breakpoint = true;
        let side = *directions.get(index % directions.len()).unwrap();
        let next_locations = get_next_location(side, begins.clone(), elements.clone());
        let mut next_begins:Vec<Element> = Vec::new();
        index += 1;
        for next in next_locations.iter(){
            print!("\t{:?}",next);
            if !next.chars().last().unwrap().eq_ignore_ascii_case(&END){ 
                breakpoint = false; break;
            }
        }
        println!("\t\t{:?}",index);

        if breakpoint { break; }
        else{
            for next in next_locations{
                next_begins.push(Element::new(next));
            }
            begins = next_begins;
        }
    }

    println!("{:?}",index);
}

fn get_next_location(side:char,current_locations:Vec<Element>,elements:Vec<Element>) -> Vec<String>{
    let mut return_vec:Vec<String> = Vec::new();
    for current_location in current_locations{
        let current_location_name = current_location.get_name().to_string();
        let mut next_location_name = String::new();
        for element in elements.iter(){
            if element.get_name() == current_location_name.clone(){
                match side{
                    LEFT => {
                        next_location_name = element.left();
                        break;
                    },
                    RIGHT => {
                        next_location_name = element.right();
                        break;
                    },
                    _ => { panic!();}
                }
            }
        };
        print!("{:?}",next_location_name);
        return_vec.push(next_location_name);
    };
    return return_vec;
}

#[derive(Clone,Debug)]
struct Element{
    name:String,
    left_side:String,
    right_side:String,
}

impl Element{
    fn new(name:String) -> Self { Self{name, left_side:String::new(),right_side:String::new()} }

    fn get_name(&self) -> &str { &self.name }

    fn left(&self) -> String { self.left_side.clone() }
    fn right(&self) -> String { self.right_side.clone() }
}

impl PartialEq for Element{
    fn eq(&self, other: &Self) -> bool { self.name.eq(&other.name) }
}
